----------------------------------
-- DYNAMIC SQL AND SYSTEM PACKAGES
----------------------------------
/*

-- ORACLE PROVIDE MANY PACKAGES TO EXTEND THE PL/SQL FEATURES
-- MAKE SURE YOU RUN THET catproc.sql SCRIPT

-- BUT FIRST, LET'S SEE HOW TO USE DYNAMIC SQL

-- DYNAMIC SQL ALLOW YOU TO EXECUTE A SQL STATEMENT CONTAINED IN A STRING
-- VERY USEFULL FOR SCENARIOS WHERE YOU DON'T KNOW THE OBJECT'S NAME 

-- WE CAN USE THE EXECUTE IMEDIATE OR THE PROCEDURES OF THE DBMS_SQL PACKAGE
-- WHEN USEING THE DBMS_PACKAGE PERMISSIONS ARE PERFORMED ON THE BEHALF OF THE USER 
   EXECUTING THEM
   
-- EXECUTE IMMEDIATE IS USED WHEN YOU WANT TO RETORN JUST ONE ROW.
-- EXAMPLES:

SELECT EMPLOYEE_iD,
       SALARY,
       LAST_NAME
FROM HR.EMPLOYEES


BEGIN
  
  EXECUTE IMMEDIATE 'UPDATE HR.EMPLOYEES
                     SET SALARY = SALARY + 1
                     WHERE EMPLOYEE_ID = 207';
  
END;

-- FOR STRINGS, EACH ' REQUIRE A PAIR OF ''. EXAMPLE

BEGIN
  
  EXECUTE IMMEDIATE 'UPDATE HR.EMPLOYEES
                     SET SALARY = SALARY + 1
                     WHERE LAST_NAME = ''Cores''  ';
END;

-- USE THE :<variable> PLACEHOLDER INSIDE THE STRING TO SEND VALUES TO 
   THE DYNAMIC EXECUTION + THE USING KEYWORD
   
--  COMBINE THESES PLACEHOLDERS WITH PARAMETERS.
   
-- EXAMPLES:
   
DECLARE
  E_ID NUMBER(4);
BEGIN
  
  E_ID := 207;
  
  EXECUTE IMMEDIATE 'UPDATE HR.EMPLOYEES
                     SET SALARY = SALARY + 1
                     WHERE EMPLOYEE_ID = :E_ID'
  USING IN E_ID;
END;

-- TO GET THE RESULT OF A DYNAMIC SQL USE THE INTO CLAUSE WITH A ADEQUATE VARIABLE.
-- EXAMPLE:

SELECT * FROM HR.COUNTRIES;   
   
DECLARE
  a_code  CHAR(2);  
  contries_rec HR.COUNTRIES%ROWTYPE;
BEGIN
  a_code := 'BR';
  
  EXECUTE IMMEDIATE 'SELECT * FROM HR.COUNTRIES WHERE COUNTRY_ID = :x'
  INTO contries_rec  USING a_code;

  DBMS_OUTPUT.PUT_LINE('Country Name: ' || contries_rec.COUNTRY_NAME );
END;
   
-- MAIN ORACLE-SUPPLIED PACKAGES:


DBMS_ALERT           -> NOTIFICATION OF DATABASE EVENTS
DBMS_APLICATION_INFO -> INFORM THE ORACLE DATABASE ABOUT WHAT THE APP. IS DOING
DBMS_DESCRIBE        -> DESCRIPTION FOR ARGUMENTS OF STORED PROCEDURES
DBMS_LOCK            -> HANDLE LOCKS 
DBMS_SESSION         -> ACCESS TO SQL SESSION INFORMATION
DBMS_SHARED_POOL     -> CONTROL THE OBJECTS IN THE SHARED MEMORY
DBMS_TRANSACTION     -> CONTROLS LOGICAL TRANSACTIONS
DBS_UTILITY          -> ANALYZE OBJECTS

-- THERE ARE ALSO TWO VERY HANDY PACKAGES:

    -> UTL_FILE: TEXT FILE AND I/O FEATURES (OPEN, READ, WRITE AND CLOSE FILES)
    -> DBMS_LOB: READ OPERATIONS ON EXTERNAL BFILES
    -> URL_HTTP: HTTP CALLOUT FROM PL/SQL. EXAMPLE:
    
    SELECT UTL_HTTP.REQUEST('http://www.google.com')
    FROM DUAL;
    
    -> NOTE: YOU NEED TO SETUP THE ENVIRONMENT FOR A HTTP CALLOUT

*/
